#include <iostream>
#include <vector>
#include <string>
#include "svg.h"
using namespace std;

void svg_text(double left, double baseline, string text) {
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}

void svg_rect(double x, double y, double width, double height) {
    cout << "<rect x='" << x<< "' y='" << y<< "' width='" << width<< "' height='" << height<< "' />\n";
}

void svg_begin(double width, double height) {
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end() {
    cout << "</svg>\n";
}

void show_histogram_svg(const vector<size_t>& bins) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_BASELINE = 20;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    svg_begin(400, 300);
    double top = 0;
    size_t max_bin = 0;
    for (size_t bin : bins) {
        if (bin > max_bin) {
            max_bin = bin;
        }
    }
    for (size_t bin : bins) {
        const double bin_width = BLOCK_WIDTH * bin;
        const double text_left = BLOCK_WIDTH * max_bin;
        const double rect_left = text_left - bin_width;
        svg_rect(rect_left, top, bin_width, BIN_HEIGHT);
        svg_text(text_left, top + TEXT_BASELINE, to_string(bin));
        top += BIN_HEIGHT;
    }
    svg_end();
}
